// D import file generated from 'derelict/util/sharedlib.d'
module derelict.util.sharedlib;
import std.string;
import std.conv;
import derelict.util.exception;
import derelict.util.system;
alias SharedLibHandle = void*;
static if (Derelict_OS_Posix)
{
	import core.sys.posix.dlfcn;
	private 
	{
		SharedLibHandle LoadSharedLib(string libName);
		void UnloadSharedLib(SharedLibHandle hlib);
		void* GetSymbol(SharedLibHandle hlib, string symbolName);
		string GetErrorStr();
	}
}
else
{
	static if (Derelict_OS_Windows)
	{
		import derelict.util.wintypes;
		private 
		{
			SharedLibHandle LoadSharedLib(string libName);
			void UnloadSharedLib(SharedLibHandle hlib);
			void* GetSymbol(SharedLibHandle hlib, string symbolName);
			string GetErrorStr();
		}
	}
	else
	{
		static assert(0, "Derelict does not support this platform.");
	}
}
struct SharedLib
{
	private 
	{
		string _name;
		SharedLibHandle _hlib;
		private MissingSymbolCallbackDg _onMissingSym;
	}
	public 
	{
		void load(string[] names);
		void* loadSymbol(string symbolName, bool doThrow = true);
		void unload();
		@property 
		{
			string name();
			bool isLoaded();
			void missingSymbolCallback(MissingSymbolCallbackDg callback);
			void missingSymbolCallback(MissingSymbolCallbackFunc callback);
			MissingSymbolCallback missingSymbolCallback();
		}
	}
}
